///////////////////////////////////////////////////////////////////////////////
//
//  $Id: Ferret.xs,v 1.14 1996/09/07 04:31:37 bcwhite Exp $
//
//  Ferret Search Engine -- perl interface to class
//
//  Written by:  Brian C. White
//  Copyright (c) 1996 by Verisim, Inc.  All rights reserved.
//
///////////////////////////////////////////////////////////////////////////////
//
//  Description
//  ~~~~~~~~~~~
//
///////////////////////////////////////////////////////////////////////////////


#ifdef __cplusplus
 extern "C" {
#endif
#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>
#ifdef __cplusplus
 }
#endif

#include "ferret/common.h"
#include "ferret/ferret.h"




struct StringRef {
	SV*		ref;
	char*	data;
	uint	len;
};


static double
constant(char* name, int arg)
{
    errno = 0;
    switch (*name) {
    case 'A':
	break;
    case 'B':
	break;
    case 'C':
	break;
    case 'D':
	break;
    case 'E':
	break;
    case 'F':
	break;
    case 'G':
	break;
    case 'H':
	break;
    case 'I':
	break;
    case 'J':
	break;
    case 'K':
	break;
    case 'L':
	break;
    case 'M':
	break;
    case 'N':
	break;
    case 'O':
	if (strEQ(name, "OPT_TINY"))		return(Ferret::OPT_TINY);
	if (strEQ(name, "OPT_NOSTOPPERS"))	return(Ferret::OPT_NOSTOPPERS);
	break;
    case 'P':
	break;
    case 'Q':
	break;
    case 'R':
	break;
    case 'S':
	break;
    case 'T':
	break;
    case 'U':
	break;
    case 'V':
	break;
    case 'W':
	break;
    case 'X':
	break;
    case 'Y':
	break;
    case 'Z':
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}



//PROTOTYPES: DISABLE

MODULE = Ferret	PACKAGE = Ferret



double
constant( name, arg )
	char	*name
	int	arg



Ferret *
Ferret::new()

void
Ferret::DESTROY()



void
Message( )
	CODE:
	Ferret::Message();

void
StripNonWords( String )
	StringRef	String
	CODE:
	String.len = Ferret::StripNonWords(String.data,String.len);
	CLEANUP:
	SvCUR_set(String.ref, String.len);

void
StripWords( String, Stops, ... )
	StringRef	String
	StringRef	Stops
	CODE:
	char*	words[items+1-2];
	I32		wcount;
	for (wcount=2; wcount < items; wcount++) {
		words[wcount-2] = (char*)SvPV(ST(wcount),na);
	}
	words[wcount-2] = 0;
	String.len = Ferret::StripWords(String.data,String.len,Stops.data,words);
	CLEANUP:
	SvCUR_set(String.ref, String.len);

void
StripBadLines( String )
	StringRef	String
	CODE:
	String.len = Ferret::StripBadLines(String.data,String.len);
	CLEANUP:
	SvCUR_set(String.ref, String.len);


int
Ferret::SetOptionFlag( Opt )
	unsigned long	Opt

int
Ferret::UnsetOptionFlag( Opt )
	unsigned long	Opt

unsigned long
Ferret::Options( )



int
Ferret::OpenIndex( File, Mode=0 )
	char	*File
	int	Mode

int
Ferret::CloseIndex( )

int
Ferret::FlushIndex( )

int
Ferret::ShrinkIndex( )



char *
Ferret::DBGetWords( Key )
	char	*Key

int
Ferret::DBPutWords( Key, Val )
	char	*Key
	char	*Val


char *
Ferret::DBGetUser( Key )
	char	*Key

int
Ferret::DBPutUser( Key, Val )
	char	*Key
	char	*Val

int
Ferret::DBDelUser( Key )
	char	*Key


char *
Ferret::DBGetSummary( Key )
	char	*Key

int
Ferret::DBPutSummary( Key, Val )
	char	*Key
	char	*Val

int
Ferret::DBDelSummary( Key )
	char	*Key


char *
Ferret::DBGetTitle( Key )
	char	*Key

int
Ferret::DBPutTitle( Key, Val )
	char	*Key
	char	*Val

int
Ferret::DBDelTitle( Key )
	char	*Key


char *
Ferret::CommonWords( Min, Max=-1.0 )
	double	Min
	double	Max

char *
Ferret::ListDocuments( )



unsigned long
Ferret::DocumentTimestamp( Name )
	char	*Name

char *
Ferret::AddDocumentWords( Name, Words )
	char	*Name
	char	*Words

int
Ferret::RemoveDocumentWords( Name )
	char	*Name

int
Ferret::MoveDocumentWords( OldName, NewName )
	char	*OldName
	char	*NewName



char *
Ferret::QueryResults( Result )
	int	Result

int
Ferret::QueryWord( Word )
	char	*Word

int
Ferret::QueryNegate( Result )
	int	Result

int
Ferret::QueryAnd( Left, Right, Proximity=0 )
	int	Left
	int	Right
	int	Proximity

int
Ferret::QueryOr( Left, Right )
	int	Left
	int	Right

void
Ferret::FreeQueryResult( Result )
	int	Result
